/*
 * ReadTag2.java
 */

import java.io.*;
import java.net.*;

public class ReadTag2 {
    /** ReadTag IuWFNgǂݎtqk */
    protected URL myURL = null;
    /** ̃IuWFNgReader */
    protected BufferedReader inrdr = null;

    /** ReadTagNX̎ĝЂƂȒPȃCvO */
    public static void main(String[] args)
	throws MalformedURLException, IOException {
	if (args.length == 0) {
	    System.err.println("Usage:ReadTag URL [...]");
	    return;
	}
	for (int i = 0; i < args.length; i++) {
	    ReadTag2 rt = new ReadTag2(args[0]);
	    String tag;
	    while ((tag = rt.nextTag()) != null) {
		System.out.println(tag);
	    }
	    rt.close();
	}
    }

    /** ^ꂽtqk̕ReadTag𐶐 */
    public ReadTag2(String theURLString)
	throws IOException, MalformedURLException {
	this(new URL(theURLString));
    }

    /** ^ꂽtqkReadTag𐶐 */
    public ReadTag2(URL theURL) throws IOException{
	myURL = theURL;
	// ǂݎ̑ΏۂƂȂtqkJ
	try{
	    inrdr = new BufferedReader(new InputStreamReader(myURL.openStream(),"JISAutoDetect"));
	}catch(Exception e){
	    System.out.print("N");
	    //System.out.println("error1:"+e.getMessage());
	}
    }


    /** ̃^Oǂ */
    public String nextTag() throws IOException {
	int i;
	try{
	    while ((i = inrdr.read()) != -1) {
		char thisChar = (char) i;
		if (thisChar == '<') {
		    String tag = readTag();
		    return tag;
		}
	    }

	}catch(IOException e){
	    System.out.println("nextTag error:"+e);
	    return null;
	}
	return null;
    }

    public void close() throws IOException {
	inrdr.close();
    }

    /** ^OǂށBElliotte Rusty Harold̃R[hpĂ */
    public String readTag() throws IOException {
	StringBuffer theTag = new StringBuffer("<");
	int i = '<';
	try{
	    while (i != '>' && (i = inrdr.read()) != -1) {
		theTag.append((char) i);
	    }
	}catch(IOException e){
	    System.out.println("readTag error:"+e);
	}
	return theTag.toString();
    }


    /** topic^OԂ */
    protected String readTopicTag(String EndTag) throws IOException {
	StringBuffer tags = new StringBuffer();
	int flag = 0;
	int i = '>';
	try{
	    while(flag==0){
		while (i != '<' && (i = inrdr.read()) != -1) {
		    tags.append((char) i);
		}
		if(i==-1){
		    flag = 1;
		    break;
		}
		StringBuffer endtag = new StringBuffer();
		// i == '<'
		endtag.append('<');
		while(i != '>' && (i = inrdr.read()) != -1){
		    tags.append((char) i);
		    endtag.append((char) i);
		}
		if(i==-1){
		    flag = 1;
		    break;
		}

		// tags == <..>...."</..>" or <..>...."<...>"...
		String str_endtag = endtag.toString();
		if(EndTag.startsWith(str_endtag))
		    flag = 1;
		if(str_endtag.equals("</HTML>") || str_endtag.equals("</html>")){
		    tags = endtag;
		    flag = 1;
		}
	    }// end while

	}catch(Exception e){
	    System.out.println("readTopicTag error:"+e);
	}
	return tags.toString();
    }


    /** ̃IuWFNg\StringԂ */
    public String toString() {
	return "ReadTag2[" + myURL.toString() + "]";
    }

}
